routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'Frontend\PageController@landing')->name('landing');
Route::get('/about', 'Frontend\PageController@pageAbout')->name('page.about');
Route::post('/vehicle/detail', 'Frontend\PageController@showVehicle')->name('vehicle.detail');

Route::group(['middleware' => ['auth', 'role:member']], function () {
    Route::get('/booking/cart', 'Frontend\PageController@cart')->name('cart.index');
    Route::get('/booking/{company_id}/checkout', 'Frontend\PageController@checkout')->name('checkout');
    Route::get('/booking/{invoice}/confirm', 'Frontend\PageController@confirm')->name('confirm');
    Route::post('/booking/{invoice}/confirm', 'Frontend\PageController@confirmStore')->name('confirm.store');
    Route::post('/booking/{company_id}/checkout', 'Frontend\PageController@checkoutStore')->name('checkout.store');
    Route::post('/booking/cart', 'Frontend\PageController@addToCart')->name('cart.add');
    Route::post('/booking/cart/remove', 'Frontend\PageController@removeItemCart')->name('cart.remove');
    Route::post('/booking/cart/update', 'Frontend\PageController@updateCart')->name('cart.update');
    Route::post('/booking/cart/dateadd', 'Frontend\PageController@addDateCart')->name('cart.dateadd');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('/account/profile', 'ProfileController@show')->name('profile.show');
Route::put('/account/profile', 'ProfileController@update')->name('profile.update');
Route::put('/account/profile/member', 'ProfileController@updateMember')->name('profile.update.member');

Route::group(['prefix' => 'main', 'middleware' => ['auth', 'role:admin']], function () {
    Route::get('user', 'Backend\UserController@index' )->name('user.index');
    Route::post('user', 'Backend\UserController@store' )->name('user.store');
    Route::get('user/create', 'Backend\UserController@create' )->name('user.create');
    Route::get('user/{id}/edit', 'Backend\UserController@edit' )->name('user.edit');
    Route::put('user/{id}/update', 'Backend\UserController@update' )->name('user.update');
    Route::delete('user/{id}', 'Backend\UserController@destroy' )->name('user.destroy');

    Route::resource('booking','Backend\BookingController', ['only' => ['index', 'show', 'update']]);
    Route::resource('payment','Backend\PaymentController', ['only' => ['index', 'show', 'update']]);
    Route::resource('company','Backend\CompanyController', ['only' => ['index', 'show']]);
    Route::post('company.verification', 'Backend\CompanyController@verification')->name('company.verification');
    Route::resource('payouts', 'Backend\PayoutController', ['only' => ['index', 'show', 'update']]);
});

Route::group(['prefix' => 'intern', 'middleware' => ['auth', 'role:member']], function () {
    Route::resource('vehicle', 'Frontend\VehicleController');
    Route::resource('payout','Frontend\PayoutController', ['only' => ['index', 'show', 'create', 'store']]);
    Route::resource('transaction_in', 'Frontend\TransInController', ['only' => ['index', 'show', 'edit', 'update']]);
    Route::resource('transaction_out', 'Frontend\TransOutController', ['only' => ['index', 'show']]);
});

app/Http/Controllers/Frontend/PageController.php
<?php

namespace App\Http\Controllers\Frontend;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Vehicle;
use App\Booking;
use App\BookingDetail;
use App\Payment;
use Session;

class PageController extends Controller
{
    public function landing(Request $request)
    {
        $vehicles = Vehicle::where('status', 100);

        $condition = (env('DB_CONNECTION', 'mysql') == 'pgsql') ? 'ilike' : 'like';

        if ($request->get('q') != null) {
            if ($request->q != 'all') {
                $vehicles->where('name', $condition, '%' . $request->q . '%');
            }
        }

        $vehicles = $vehicles->paginate(8);

        $q = $request->q;
        $company_id = null;
        if (\Auth::check()) {
            if (\Auth::user()->role == 'member') {
                $company_id = \Auth::user()->company->id;
            }
        }

        return view('frontend.pages.landing')->with(compact('vehicles', 'q', 'company_id'));
    }

    public function pageAbout()
    {
        return view('frontend.pages.about');
    }

    public function showVehicle(Request $request)
    {
        $vehicle = Vehicle::with('company')->find($request->id);

        return response()->json($vehicle);
    }

    public function Cart(Request $request)
    {
        $carts = session('cart') ?? [];
        //dd($carts);
        return view('frontend.pages.cart')->with(compact('carts'));
    }

    public function addToCart(Request $request)
    {
        $id = $request->bus_id;
        $vehicle = Vehicle::find($id);

        $cart = session()->get('cart');
        
        $company_id = $vehicle->company_id;
        $company_name = $vehicle->company->name;
        // if cart is empty then this the first product
        if (!$cart) {
            $cart = [
                $company_id => [
                    'company_name' => $company_name,
                    'data' => [
                        $id => [
                            "id" => $vehicle->id,
                            "name" => $vehicle->name,
                            "quantity" => 1,
                            "available" => $vehicle->available,
                            "image_url" => asset('uploads/images/vehicles/' . $vehicle->image),
                            "seat" => $vehicle->seat,
                            "price" => $vehicle->price
                        ]
                    ]
                ]
            ];

            session()->put('cart', $cart);

            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Bus berhasil ditambahkan ke list booking"
            ]);

            return redirect()->back();
        }

        // if cart not empty then check if this product exist then increment quantity
        if (isset($cart[$company_id]['data'][$id])) {

            if($cart[$company_id]['data'][$id]['quantity'] < $cart[$company_id]['data'][$id]['available']){
                $cart[$company_id]['data'][$id]['quantity']++;
            }

            session()->put('cart', $cart);

            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Bus berhasil ditambahkan ke list booking"
            ]);
            return redirect()->back();
        }

        // if item not exist in cart then add to cart with quantity = 1
        $cart[$company_id]['company_name'] = $company_name;
        $cart[$company_id]['data'][$id] = [
            "id" => $vehicle->id,
            "name" => $vehicle->name,
            "quantity" => 1,
            "available" => $vehicle->available,
            "image_url" => asset('uploads/images/vehicles/' . $vehicle->image),
            "seat" => $vehicle->seat,
            "price" => $vehicle->price
        ];

        session()->put('cart', $cart);

        Session::flash("swal_notification", [
            "level" => "success",
            "message" => "Bus berhasil ditambahkan ke list booking"
        ]);
        return redirect()->back();
    }

    public function updateCart(Request $request)
    {
        $status = 0;
        if ($request->company_id and $request->vehicle_id and $request->quantity) {
            $cart = session()->get('cart');

            $cart[$request->company_id]['data'][$request->vehicle_id]['quantity'] = $request->quantity;

            session()->put('cart', $cart);

            $status = 1;
        }
        if ($status == 1) {
            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Tanggal sewa berhasil ditambahkan"
            ]);
        } else {
            Session::flash("swal_notification", [
                "level" => "error",
                "message" => "Gagal terjadi kesalahan!"
            ]);
        }

        return redirect()->back();
    }

    public function addDateCart(Request $request)
    {
        $status = 0;
        if ($request->company_id and $request->start_date and $request->end_date) {
            $cart = session()->get('cart');

            $cart[$request->company_id]['date_range'] = $request->date_range;
            $cart[$request->company_id]['start_date'] = $request->start_date;
            $cart[$request->company_id]['end_date'] = $request->end_date;
            $cart[$request->company_id]['diff_days'] = $request->diff_days;

            session()->put('cart', $cart);

            $status = 1;
        }
        
        if ($status == 1) {
            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Tanggal sewa berhasil ditambahkan"
            ]);
        } else {
            Session::flash("swal_notification", [
                "level" => "error",
                "message" => "Gagal terjadi kesalahan!"
            ]);
        }
        return redirect()->back();
    }

    public function removeItemCart(Request $request)
    {
        $status = 0;
        if ($request->company_id and $request->vehicle_id) {

            $cart = session()->get('cart');
            if (isset($cart[$request->company_id]['data'][$request->vehicle_id])) {

                unset($cart[$request->company_id]['data'][$request->vehicle_id]);

                if (empty($cart[$request->company_id]['data'])) {
                    unset($cart[$request->company_id]);
                }

                session()->put('cart', $cart);

                $status = 1;
            }
        }
        if ($status == 1) {
            Session::flash("swal_notification", [
                "level" => "success",
                "message" => "Bus berhasil dihapus"
            ]);
        } else {
            Session::flash("swal_notification", [
                "level" => "error",
                "message" => "Gagal terjadi kesalahan!"
            ]);
        }
        return redirect()->back();
    }

    public function checkout($company_id)
    {
        $cart = session('cart')[$company_id] ?? [];

        if (empty($cart)) {
            abort(404);
        }

        return view('frontend.pages.checkout')->with(compact('cart', 'company_id'));
    }

    public function checkoutStore(Request $request, $company_id)
    {
        $cart = session('cart')[$company_id] ?? [];
        if (empty($cart)) {
            abort(404);
        }

        $booking = new Booking();
        $booking->invoice = strtoupper(uniqid());
        $booking->customer_id = \Auth::user()->id;
        $booking->company_id = $company_id;
        $booking->start_date = $cart['start_date'] ?? date('Y-m-d');
        $booking->end_date = $cart['end_date'] ?? date('Y-m-d');
        $booking->notes = $request->notes;
        $booking->vehicle_total = 0;
        $booking->price_total = 0;
        $booking->payment_method = $request->method;
        $booking->save();

        $price_total = 0;
        $vehicle_total = 0;
        $subtotal = 0;
        foreach ($cart['data'] as $key => $item) {
            $detail = new BookingDetail();
            $detail->booking_id = $booking->id;
            $detail->vehicle_id = $item['id'];
            $detail->quantity = $item['quantity'];
            $detail->price = $item['price'];
            $detail->save();

            $price_total = $item['quantity'] * $item['price'];
            $subtotal += $price_total;
            $vehicle_total += $item['quantity'];
        }

        $booking->vehicle_total = $vehicle_total;
        $booking->price_total = $subtotal * ($cart['diff_days'] ?? 1);
        $booking->save();

        // remove cart
        $carts = session('cart');
        unset($carts[$request->company_id]);
        session()->put('cart', $carts);

        Session::flash("swal_notification", [
            "level" => "success",
            "message" => "Checkout berhasil, silahkan lakukan pembayaran"
        ]);
        return redirect()->route('confirm', $booking->invoice);
    }

    public function confirm($invoice)
    {
        $booking = Booking::whereInvoice($invoice)->where('customer_id', \Auth::user()->id)->first();

        if (!$booking) {
            abort(404);
        }

        $bank = config('app-data.bank')[$booking->payment_method];  
        $banks = json_decode(config('app-data.banks'), true);

        return view('frontend.pages.confirm')->with(compact('booking', 'bank', 'banks'));
    }

    public function confirmStore(Request $request, $invoice)
    {
        $this->validate($request, [
            'confirm_bank' => 'required|string',
            'confirm_account_holder' => 'required|string',
            'payment_image' => 'required|image',
        ]);

        $booking = Booking::whereInvoice($invoice)->first();

        $payment = new Payment();
        $payment->booking_id = $booking->id;
        $payment->method = $request->confirm_bank;
        $payment->account_holder = $request->confirm_account_holder;
        $payment->paid = $booking->price_total;

app/Http/Controllers/Frontend/TransInController.php
<?php

namespace App\Http\Controllers\Frontend;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Support\Facades\File;
use Yajra\Datatables\Datatables;
use App\User;
use App\Company;
use App\Vehicle;
use App\Booking;
use App\BookingDetail;
use Auth;
use Session;
use Carbon\Carbon;

class TransInController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        if ($request->ajax()) {

            $company_id = Auth::user()->company->id;
            $trans_ins = Booking::with('customer', 'customer.company')->where('company_id', $company_id);

            if ($request->get('status') != null) {
                if ($request->status != 'all') {
                    $trans_ins->whereStatus($request->status);
                }
            }

            $trans_ins = $trans_ins->select('bookings.*');

            return Datatables::of($trans_ins)
                ->addIndexColumn()
                ->addColumn('action', function ($trans_in) {
                    return view('partials._action', [
                        'model'           => $trans_in,
                        'show_url'        => route('transaction_in.show', $trans_in->id),
                        'reject_url'        => route('transaction_in.edit', $trans_in->id)
                    ]);
                })
                ->escapeColumns([])
                ->make(true);
        }

        return view('frontend.trans_in.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $booking = Booking::find($id);

        $end = Carbon::parse($booking->end_date);
        $start = Carbon::parse($booking->start_date);
        $diff_days = $end->diffInDays($start) + 1;

        return view('frontend.trans_in.show')->with(compact('booking', 'diff_days'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $booking = Booking::find($id);

        $end = Carbon::parse($booking->end_date);
        $start = Carbon::parse($booking->start_date);
        $diff_days = $end->diffInDays($start) + 1;

        return view('frontend.trans_in.edit')->with(compact('booking', 'diff_days'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'reject_reason' => 'required|string'
        ]);

        $booking = Booking::find($id);
        $booking->status = 10;
        $booking->reject_reason = $request->reject_reason;
        $booking->save();

        Session::flash("flash_notification", [
            "level" => "success",
            "message" => "Penyewaan ini berhasil dibatalkan"
        ]);

        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/frontend/vehicles/create.blade.php
@extends('layouts.front')

@section('css')
  <link rel="stylesheet" href="{{ asset('assets/stisla/modules/summernote/summernote-bs4.css') }}">
@endsection

@section('content')
  <section class="section">
    <div class="section-header">
      <h1>Tambah Bus</h1>
    </div>

    <form method="POST" action="{{ route('vehicle.store') }}" enctype="multipart/form-data">
      <div class="row">
        <div class="col-lg-8">
          <div class="card card-danger">
            <div class="card-header py-3">
              <h6 class="m-0 font-weight-bold">Informasi Bus</h6>
            </div>
            <div class="card-body">
              {{ csrf_field() }}

              <div class="row">
                <div class="form-group col-8 {{ $errors->has('name') ? ' has-error' : '' }}">
                  <label for="name">Nama Bus</label>
                  <input id="name" type="text" class="form-control @if ($errors->has('name')) is-invalid @endif" name="name" value="{{ old('name') }}">
                  @if ($errors->has('name'))
                    <div class="invalid-feedback">
                      {{ $errors->first('name') }}
                    </div>
                  @endif
                </div>
                
                <div class="form-group col-4 {{ $errors->has('seat') ? ' has-error' : '' }}">
                  <label for="seat">Kapasitas Kursi</label>
                  <input id="seat" type="number" class="form-control @if ($errors->has('seat')) is-invalid @endif" name="seat" value="{{ old('seat') }}">
                  @if ($errors->has('seat'))
                    <div class="invalid-feedback">
                      {{ $errors->first('seat') }}
                    </div>
                  @endif
                </div>
              </div>

              <div class="form-group {{ $errors->has('description') ? ' has-error' : '' }}">
                <label for="description">Deskripsi Bus</label>
                <textarea id="description" class="summernote @if ($errors->has('description')) is-invalid @endif" name="description" ></textarea>
                @if ($errors->has('description'))
                  <div class="invalid-feedback">
                    {{ $errors->first('description') }}
                  </div>
                @endif
              </div>
              
              <div class="row">
                <div class="form-group col-4 {{ $errors->has('available') ? ' has-error' : '' }}">
                  <label for="available" class="d-block">Jumlah Bus Tersedia</label>
                  <input id="available" type="number" class="form-control @if ($errors->has('available')) is-invalid @endif" name="available">
                  @if ($errors->has('available'))
                    <div class="invalid-feedback">
                      <strong>{{ $errors->first('available') }}</strong>
                    </div>
                  @endif
                </div>
                <div class="form-group col-8 {{ $errors->has('price') ? ' has-error' : '' }}">
                  <label for="price" class="d-block">Harga Sewa (per-1 hari)</label>
                  <input id="price" type="number" class="form-control @if ($errors->has('price')) is-invalid @endif" name="price">
                  @if ($errors->has('price'))
                    <div class="invalid-feedback">
                      <strong>{{ $errors->first('price') }}</strong>
                    </div>
                  @endif
                </div>
              </div>

              <div class="form-group">
                <button type="submit" class="btn btn-danger btn-block" tabindex="4">
                  Simpan
                </button>
              </div>
              
            </div>
          </div>
        </div>

        <div class="col-lg-4">
          <div class="card card-danger">
            <div class="card-header py-3">
              <h6 class="m-0 font-weight-bold">Foto Bus</h6>
            </div>
            <div class="card-body">
              <div class="form-group">
                <div class="text-center">
                  <img src="{{ asset('assets/stisla/img/example-image.jpg') }}" class="rounded" id="image-prev" width="200" height="200" alt="image">
                </div>
              </div>
              <div class="form-group custom-file mb-3">
                <input id="image" type="file" class="custom-file-input {{ $errors->has('image') ? ' has-error' : '' }}" name="image">
                <label class="custom-file-label" for="customFile">Pilih Gambar</label>
              </div>
              @if ($errors->has('image'))
                <div class="invalid-feedback">
                  <strong>{{ $errors->first('image') }}</strong>
                </div>
              @endif
            </div>
          </div>
        </div>
      </div>
    </form>
  </section>
@endsection

@section('script')
  <script src="{{ asset('assets/stisla/modules/summernote/summernote-bs4.js') }}"></script>
  <script>
     $(".summernote").summernote({
        dialogsInBody: true,
        minHeight: 150,
        toolbar: [
          ['style', ['style']],
          ['font', ['bold', 'underline', 'clear']],
          ['fontname', ['fontname']],
          ['color', ['color']],
          ['para', ['ul', 'ol', 'paragraph']],
          ['view', ['codeview', 'help']],
        ],
    });

    $(document).ready(function () {
      bsCustomFileInput.init()
      $('.select2').select2();
    })

    function readURL(input) {
    if (input.files && input.files[0]) {
      var reader = new FileReader();
      reader.onload = function(e) {
        $('#image-prev').attr('src', e.target.result);
      }
      reader.readAsDataURL(input.files[0]); // convert to base64 string
      }
    }

    $("#image").change(function() {
      readURL(this);
    });
  </script>
@endsection

resources/views/frontend/vehicles/index.blade.php
@extends('layouts.front')

@section('content')
  <section class="section">
    <div class="section-header">
      <h1>Bus</h1>
    </div>

    <div class="d-sm-flex align-items-center justify-content-start mb-4">
      <a class="btn btn-sm btn-danger mr-auto" href="{{ route('vehicle.create') }}"><i class="fa fa-plus"></i> Tambah Bus</a> 
      <div class="form-inline">
        <label>Filter Status</label>
        <select name="status" class="form-control-sm ml-2">
          <option value="all">Semua</option>
          <option value="100">Aktif</option>
          <option value="10">Tidak Aktif</option>
        </select>
        <button class="btn btn-sm btn-danger ml-2" id="btn-filter"><i class="fas fa-filter"></i></button>
      </div>
    </div>

    <div class="row">
      <div class="col-lg-12">

        <!-- Basic Card Example -->
        <div class="card card-danger">
          <div class="card-header py-3">
            <h6 class="m-0 font-weight-bold">List Bus</h6>
          </div>
          <div class="card-body">

          <div class="table-responsive">
            <table class="table table-striped datatable">
              <thead>                                 
                <tr>
                  <th>#</th>
                  <th>Nama</th>
                  <th>Jml. Kursi</th>
                  <th>Jml. Tersedia</th>
                  <th>Harga (per-1 hari)</th>
                  <th>Status</th>
                  <th>Aksi</th>
                </tr>
              </thead>
              <tbody></tbody>
            </table>
          </div>

          </div>
        </div>
      </div>
    </div>
  </section>
@endsection
@section('script')
<script>
  $(document).ready(function() {
      $('.datatable').DataTable({
          processing: true,
          serverSide: true,
          autoWidth: false,
          language: {
              url: '{{ asset('assets/stisla/modules/datatables/lang/Indonesian.json') }}'
          },
          ajax: {
            url: '{{ route('vehicle.index') }}',
            data: function (d) {
              d.status = $('select[name=status]').val()
            }
          },
          columns: [
            {data: 'DT_RowIndex', name: 'DT_RowIndex', orderable: false, searchable: false},
            {data: 'name', name: 'name'},
            {data: 'seat', name: 'seat'},
            {data: 'available', name: 'available'},
            {data: null, name: 'price', render: function ( data, type, row ) {
              return 'Rp '+numberFormat(data.price)+'</span>';
            }},
            {data: 'display_status', name: 'status', orderable: false, searchable: false},
            {data: 'action', name: 'action', orderable: false, searchable: false},
          ]
      });

      $('#btn-filter').click(function(){
         $('.datatable').DataTable().draw(true);
      });

      $(document).on('click','.js-submit-confirm', function(e){
          e.preventDefault();
          swal({
            title: 'Apakah anda yakin ingin menghapus?',
            text: 'Data yang sudah dihapus, tidak dapat dikembalikan!',
            icon: 'warning',
            buttons: true,
            dangerMode: true,
          })
          .then((willDelete) => {
            if (willDelete) {
              $(this).closest('form').submit();
            } 
          });
      });
  });

  function numberFormat(x) {
    return x.toString().replace(/\B(?<!\.\d*)(?=(\d{3})+(?!\d))/g, ".");
  }

</script>
@endsection